/*
 * Created on 14/10/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package arsm;

import types.Stream;

/**
 * @author Braga Junior.
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PackStream {
	private Stream str;
	private byte[] id;
	private byte[] msg;
	private byte[] signature;
	private final int idByteLength =2;
	private final int msgByteLength = 4;
	private final int signatureByteLength =2;
/**
 * Message constructor
 * @param st
 * stream format:
 * [lengthId][id][lengthValue][value][signatureLength (*)][signature (*)]
 * length  - 5 bytes
 * lengthSignature - 2 bytes
 * (*) Optional
 */	

	public PackStream(types.Stream   st)
	{
		str=st;
		int idLength;
		int msgLength;
		int signLength;
		int offset; // Auxiliar Variable
		// id Length
		offset=0;
		idLength=lengthCalc(st.value,offset,idByteLength);
		//	set id
		byte[] idL= new byte[idLength];
		offset=offset+idByteLength;
		for( int j=0;j<idLength;j++)
		{
			idL[j]=st.value[offset+j];
		}
		id=idL;
		
		//Message Length
		offset=idByteLength+idLength; 
		msgLength=lengthCalc(st.value,offset,msgByteLength);
		//Set msn
		byte[] msgL = new byte[msgLength];
		offset=offset+msgByteLength; 
		for(int j=0;j<msgLength;j++)
		{
			msgL[j]=st.value[offset+j];
		}
		msg=msgL;
		
		offset=idByteLength+idLength+msgByteLength + msgLength; 
		if(st.value.length>(offset + 1))
		{
			//		 signature Length
			signLength= lengthCalc(st.value,offset,signatureByteLength);
			byte[] signL=new byte[signLength];
			
			//		 set signature
			offset=offset + signatureByteLength;
			for(int j=0;j<signLength;j++)
			{
				signL[j]=st.value[offset+j];
			}
				signature=signL;
		}
	}
	
	public PackStream(byte[] ident,byte[] msge)
	{
		id=ident;
		msg=msge;
		byte[] idL=new byte[idByteLength];
		byte[] msgL=new byte[msgByteLength];
		for(int j=0;j<idL.length;j++)
		{
			idL[j]=byteCalc(id.length,j,idByteLength);	
		}
		for(int j=0;j<msgL.length;j++)
		{
			msgL[j]=byteCalc(msg.length,j,msgByteLength);	
		}
		str=new Stream();
		str.value = cat4(idL,ident,msgL,msge);
	}

	public PackStream(byte[] ident,byte[] msge,byte[] sign)
	{
		PackStream msgTmp= new PackStream(ident,msge);
		byte[] signL = new byte[signatureByteLength];
		for(int j=0;j<signatureByteLength;j++) 
			signL[j]=byteCalc(sign.length,j,signatureByteLength);
		id=ident;
		msg=msge;
		signature=sign;
		str=new Stream();
		str.value=cat4(msgTmp.getStream().value, signL,signature, new byte[0]); 
	}

	
	
	public PackStream()
	{
		str=null;
	}
	public Stream getStream()
	{
		return str;
	}
	// 	
	public byte[] getId()
	{
		return id;
	}
	public byte[] getMsg()
{
	return msg;
}
	public int getMsgLength()
	{
		return msg.length;
	}
	public byte[] getSignature()
	{
		return signature;
	}
	public void print()
	{
		//TODO
	}
	
	int lengthCalc(byte[] l,int offset,int byteLength)
	{
		int m=1;
		int s=0;
		int t;
		for(int j=byteLength-1;j>0;j--)
		{
			t= l[j+offset]& 0xff;
			s= s + (t*m) ;
			m=256*m;
		}
		return s;
	}
	
	//this function contatenate 4 byte arrays
	byte[] cat4(byte[] src1,byte[] src2,byte[] src3, byte[] src4)
	{
		int offset;
		byte[] tmp = new byte[src1.length+src2.length+src3.length+src4.length];
		for(int j=0; j<src1.length;j++)
		{
			tmp[j]=src1[j];
		}
		offset=src1.length;
		for(int j=0; j<src2.length;j++)
		{
			tmp[offset+j]=src2[j];
		}
		offset=offset+src2.length;
		for(int j=0; j<src3.length;j++)
		{
			tmp[offset+j]=src3[j];
		}
		offset=offset+src3.length;
		for(int j=0; j<src4.length;j++)
		{
			tmp[offset + j]=src4[j];
		}
		return tmp;
	}
	
	private  static byte byteCalc(int number,int position,int qtdByte) 
		{
			number = number >> ((qtdByte - position-1)*8) ;
			number = number & 0xFF;
			Integer tempInteger = new Integer(number);	   
			return tempInteger.byteValue();	
		}

}
