package grm;

import interfaces.ExecutionManagerHelper;
import interfaces.GrmHelper;

import java.io.File;
import java.io.PrintWriter;
import java.io.FileOutputStream;
import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.CORBA.Object;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.CosNaming.NamingContextExt;

  /**
   Class GrmLauncher - Launches a GRM
   @author Andrei Goldchleger

  */
  public class GrmLauncher{


  /**
   Launches a GRM

   @param args - Should contain:<br>
   args[0] - Filename to output the server IOR

  */
    public static void main(String [] args){
      try{
        ORB orb = ORB.init(new String [] {}, null);
        POA poa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
        poa.the_POAManager().activate();
 
        GrmImpl grmImpl = new GrmImpl(orb);
        Object grmObj = poa.servant_to_reference(grmImpl);
	    // get a reference to the naming service
	    org.omg.CORBA.Object ns = orb.resolve_initial_references("NameService");
	    NamingContextExt nameService = NamingContextExtHelper.narrow( ns );
	    // register GRM object
	    nameService.rebind(nameService.to_name("GRM"), grmObj);
        
        if (args.length == 2) { // execMan.ior
          Object execManagerObj = poa.servant_to_reference(
          new ExecutionManagerImpl(orb, GrmHelper.narrow(grmObj)));
          grmImpl.registerExecutionManager(ExecutionManagerHelper.narrow(execManagerObj));
          nameService.rebind(nameService.to_name("EM"),execManagerObj);
        }

        orb.run();
      }
      catch(Exception e){
         e.printStackTrace();
      }
    }//main
 }//class


