#ifndef AsctStub_HPP
#define AsctStub_HPP

#include <string>
//#include <vector>

struct lua_State;

using std::string;
//using std::vector;

  //IMPORTANT: This class is not multithread-safe. Users of this class must ensure that
  // 'state' is safely isolated when concurrently accessed
  class AsctStub{

    private:

      struct lua_State * state;
      string asctIor_;

    public:

      const string & asctIor() {return asctIor_;}

      AsctStub(lua_State * aState, const string & aAsctIor);

      void acceptedExecutionRequest(const string & lrmIor,
                                    const string & lrmRequestId,
                                    const string & appMainRequestId,
                                    const string & appNodeRequestId);

      void requestInputFiles(const string & appMainRequestId,
                             const string & appNodeRequestId,
                             const string & destinationPath);

      void appFinished(const string & appMainRequestId,
                       const string & appNodeRequestId);
  };

#endif//AsctStub_HPP


