// LrmExperiments.hpp

#ifndef LRM_EXPERIMENTS
#define LRM_EXPERIMENTS

#include "AppInfoHolder.hpp"
#include <vector>
#include <string>
#include <map>
#include <pthread.h>

using namespace std;

extern class LrmExperiments *lrmExperiments;

class LrmExperiments {

    map<string, AppInfoHolder> & launchedAppsInfo;
    pthread_mutex_t & launchedAppsInfoLock;
    pthread_mutex_t & restart_mutex;
  
    pthread_t *expThread;
    int nRestart, nReschedules;
    vector<struct timeval> executionTimesBegin;
    vector<struct timeval> executionTimesEnd;

    int prepareExperiment (string args, int appNode);
    static void * startExperimentWrapper(void * ptr);
    void startExperiment(int *failureTimes);
  
  public:
    LrmExperiments(map<string, AppInfoHolder> & launchedAppsInfo_,
                   pthread_mutex_t & launchedAppsInfoLock_,
                   pthread_mutex_t & restart_mutex_);
  
    int prepareExperiments(string appArgs, string appNodeRequestId);
    void setTimeBegin();
    void setTimeEnd();    
    int writeExperimentData (string appMainRequestId, string appId);
   
};

#endif // LRM_EXPERIMENTS

