package asctGui;

import interfaces.ApplicationRepository;
import interfaces.ApplicationRepositoryPackage.ApplicationNotFoundException;
import interfaces.ApplicationRepositoryPackage.ApplicationRegistrationException;
import interfaces.ApplicationRepositoryPackage.BinaryCreationException;
import interfaces.ApplicationRepositoryPackage.BinaryNotFoundException;
import interfaces.ApplicationRepositoryPackage.DirectoryCreationException;
import interfaces.ApplicationRepositoryPackage.DirectoryNotEmptyException;
import interfaces.ApplicationRepositoryPackage.DirectoryNotFoundException;
import types.AppDescription;
import types.BinaryDescription;
import types.ContentDescription;

public class ApplicationRepositoryWrapper extends Thread implements
		ApplicationRepositoryWrapperInterface {
	private ApplicationRepository appRepos_;

	public ApplicationRepositoryWrapper(ApplicationRepository appRepos) {
		appRepos_ = appRepos;
	}

	public boolean createDirectory(String dirname)
			throws DirectoryCreationException {
		return appRepos_.createDirectory(dirname);
	}

	public void removeDirectory(String dirname)
			throws DirectoryNotFoundException, DirectoryNotEmptyException {
		
		appRepos_.removeDirectory(dirname); 

	}

	public ContentDescription[] listContents(String dirname)
			throws DirectoryNotFoundException {
		return appRepos_.listContents(dirname);
	}

	public void registerApplication(String dirname, String appname)
			throws ApplicationRegistrationException, DirectoryCreationException {
		appRepos_.registerApplication(dirname,appname);

	}

	public AppDescription getAppDescription(String dir_name)
			throws ApplicationNotFoundException, DirectoryNotFoundException {
		return appRepos_.getAppDescription(dir_name);
	}

	public void uploadApplicationBinary(BinaryDescription binDesc, byte[] app)
			throws BinaryCreationException, ApplicationNotFoundException,
			DirectoryNotFoundException {
		appRepos_.uploadApplicationBinary(binDesc,app);

	}

	public void deleteApplicationBinary(String dir_name, String bin_name,
			String platform) throws ApplicationNotFoundException,
			DirectoryNotFoundException, BinaryNotFoundException {
		appRepos_.deleteApplicationBinary(dir_name,bin_name,platform);

	}

	public void unregisterApplication(String dirname, String appname)
			throws ApplicationNotFoundException, DirectoryNotFoundException,
			DirectoryNotEmptyException {
		appRepos_.unregisterApplication(dirname,appname);

	}

	public String getRootName() {
		return appRepos_.getRootName();
	}

}
